  /*  main.c - powershell
   *  Copyright (C) 1999  Matt Spong <spong@glue.umd.edu>
   *  Based from zterm.c by Michael Zucci from the libzvt docs
   *
   *  A big, puffy lotsa-shells-in-one app. 
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License
   *  along with this program; if not, write to the Free Software
   *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   *
   *  Thanks to James Greenhalgh <james@tsunami.disintegration.org> for
   *  finding that obnoxious make/tcsh bug.
   */

#include "powershell.h"
  
int main (int argc, char *argv[])
{
  int i, c, cmdindex;
  char buffer[60], **p;
  GtkWidget *term, *scrollbar, * hbox, *vbox;
  enum { RIGHT, LEFT } scrollpos = LEFT;
  GString *shell, *name;
  GtkWidget * filenotebook;
  GtkWidget * filelist;
  
  GtkWidget * label;
  GtkWidget * frame;

  gchar tmpstr[512];
  char * tmp;
  gchar *temparr[1][1];

  char command[512], args[512];

  char tempstr[256];	     
  
  /* set up terminal environment */

  strcpy (Prefs.http_handler, "/usr/bin/lynx");
  strcpy (Prefs.ftp_handler, "/usr/bin/ncftp");
  strcpy (Prefs.mail_handler, "/usr/bin/pine");
  strcpy (Prefs.telnet_handler, "/usr/bin/telnet");

  InitRCFile();
  
  strcpy (FONT, Prefs.font);
  scrollbacklines = Prefs.scrollbacklines;

  env = environ;
  
  for (p = env; *p; p++);
  i = p - env;
  env_copy = (char **) g_malloc (sizeof (char *) * (i + 3));
  for (i = 0, p = env; *p; p++) {
    if (strncmp (*p, "TERM=", 5) == 0) {
      env_copy [i++] = "TERM=xterm";
    } else if ((strncmp (*p, "COLUMNS=", 8) == 0) ||
	       (strncmp (*p, "LINES=", 6) == 0)) {
      continue;
    } else {
      env_copy [i++] = *p;
    }
  }
  
  env_copy [i++] = "COLORTERM=zterm";
  env_copy [i] = NULL;
  
  gtk_init(&argc, &argv);
  
  /* process arguments */
  
  while ( (cmdindex==0) && (c=getopt(argc, argv, "le:s:rh")) != EOF ) 
    {
      switch(c)  
	{
	case 'e':
	  cmdindex = optind-1;      /* index of argv array to pass to exec */
	  break;
	  
	case 'r':
	  scrollpos = RIGHT;
	  break;
	  
	case '?':
	case 'h':
	default:
	  fprintf(stderr, "Usage: powershell [-sNN] [-l] [-r] [-e command args]\n");
	  
	  exit(1);
	  break;
	}
    }
  
  /* Create widgets and set options */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "PowerShell");
  gtk_window_set_wmclass (GTK_WINDOW (window), "powershell", "powershell");

  
  vbox = gtk_vbox_new (FALSE, 0); 
  gtk_container_add (GTK_CONTAINER (window), vbox);
  gtk_widget_show (vbox);
  
  InitMenus (vbox);
  
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_set_spacing (GTK_BOX (hbox), 2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 2);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
  gtk_widget_show (hbox);
  
  /* create notebook */
  
  notebook = gtk_notebook_new ();
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK(notebook), GTK_POS_TOP);

  GTK_WIDGET_UNSET_FLAGS (notebook, GTK_CAN_FOCUS);



  gtk_container_add (GTK_CONTAINER(hbox), notebook);
  bzero (command, 512);
  bzero (args, 512);
  
  tmp = strstr (app_entries[0].command, " ");
  if (!tmp)
    strcpy (command, app_entries[0].command);
  else
    {
      *tmp = '\0';
      strcpy (command, app_entries[0].command);
      *tmp = ' ';
      tmp++;
      strcpy (args, tmp);
    }
  

      
  gtk_signal_connect (GTK_OBJECT (window), "delete_event", GTK_SIGNAL_FUNC (quit_proggie),
		      NULL);
  
  gtk_signal_connect (GTK_OBJECT (notebook), "switch-page", 
		      GTK_SIGNAL_FUNC (NotebookHandler), NULL);

  
  /* show them all! */
  gtk_notebook_set_show_border (GTK_NOTEBOOK(notebook), FALSE);
  gtk_widget_show(notebook);
  

  sprintf (tmpstr, "PowerShell - [%s]", app_entries[0].tab_title);

  gtk_window_set_title (GTK_WINDOW(window), tmpstr);
  gtk_widget_realize (window);

  gtk_widget_show (GTK_WIDGET(window));  
  new_term (GTK_WIDGET(notebook), command, args, app_entries[0].tab_title);


  
  /* main loop */
  gtk_main ();
  gtk_exit(0);
  return 0;
}



  
